<CsoundSynthesizer>
<CsOptions>
-m128  --env:SSDIR+=../../samples/
</CsOptions>
<CsInstruments>

sr = 44100
ksmps = 32
nchnls = 16
0dbfs = 1
seed 1

/* 
gar nichts!
*/
   
;giChannelSetup = 2.0 ;nchnls must be 2 then
;giChannelSetup = 2.2 ;nchnls must be 4 then
;giChannelSetup = 4.4 ;nchnls must be 8 then
giChannelSetup = 8.8 ;nchnls must be 16 then

;globales gain (db) um die lautstärkenunterschiede durch die mischungen auszugleichen
giGlobGainDb = 0

;vbap setup 1 = 8chnls
iBox_1 = -22.5
vbaplsinit 2.01, 8, iBox_1, iBox_1+45, iBox_1+90, iBox_1+135, iBox_1+180, iBox_1-135, iBox_1-90, iBox_1-45

;vbap setup 2 = 4chnls
;iBox_1 = -45
;vbaplsinit 2.02, 4, iBox_1, iBox_1+90, iBox_1+180, iBox_1-90
vbaplsinit 2.02, 4, -30, 30, 150, 210


giPlayCnt init 0 ;für die internen audio-kanäle
giDryLevel init 0 ;eigentlich ein bisschen doppelt gemoppelt weil über ABCDE zu setzen, aber ok

;die tonfolge als proportionen (sisyphos)
giPitchSeriesProps[] fillarray 1, 9/8, 6/5, 6/7, 15/16, 6/5, 4/3, 4/5, 8/9, 5/4, 25/18, 3/4, 8/9, 4/3, 4/3, 4/5, 5/6, 5/4, 5/4, 5/6, 5/6, 4/3, 6/5

;zähler setzen
giPitchSeriesCnt = 0

;anfangstonhöhe setzen (B)
giBasePitch = 55*(16/15)


iBox_1 = -22.5
vbaplsinit 2, 8, iBox_1, iBox_1+45, iBox_1+90, iBox_1+135, iBox_1+180, iBox_1-135, iBox_1-90, iBox_1-45


/* raumbewegung:
   - B von L nach R dabei immer stärker ausschwingen
   - C von R anfangen, immer zum nächsten punkt zufällige richtung, maximal 90° entfernt
   - D mitte - halbrechts - halblinks
 */
 
/************************/
/* TABLES FOR RESONATOR */
/************************/

;esc/res 1
giFtProps1of8 ftgen 11, 0, 6, -2, 1, 11/10, 10/9, 9/8, 7/6, 6/5 ;props bis kleine terz
giFtProps2of8 ftgen 12, 0, 6, -2, 1, 10/9, 9/8, 7/6, 6/5, 5/4 ;props bis große terz
giFtProps3of8 ftgen 13, 0, 6, -2, 1, 9/8, 7/6, 6/5, 5/4, 4/3 ;props bis quarte
giFtProps4of8 ftgen 14, 0, 6, -2, 1, 7/6, 6/5, 5/4, 4/3, 3/2 ;props bis quinte
giFtProps5of8 ftgen 15, 0, 6, -2, 1, 3/2, 5/3, 7/4, 9/5, 11/6 ;zähler +2
giFtProps6of8 ftgen 16, 0, 6, -2, 1, 3/2, 5/3, 9/4, 13/5, 17/6 ;zähler +2
giFtProps7of8 ftgen 17, 0, 6, -2, 1, 3/2, 7/3, 11/4, 16/5, 23/6 ;zähler +2, 3, 4, ... und kleine abweichungen
giFtProps8of8 ftgen 18, 0, 6, -2, 1, 3/2, 7/3, 13/4, 21/5, 31/6 ;zähler +2, 4, 6, 8, 10
;esc/res 2
giFtBell1of6 ftgen 21, 0, 6, -2, 1.19, 2, 2.74, 3, 3.76, 4.07 ;jean claude bell
giFtBell2of6 ftgen 22, 0, 6, -2, 1.19, 2, 2.74, 3, 4.76, 5.07 ;oberster teilton nach oben
giFtBell3of6 ftgen 23, 0, 6, -2, 1.19, 2, 3.74, 4, 4.76, 5.07 ;mittlerer auch
giFtBell4of6 ftgen 24, 0, 6, -2, 1.19, 2, 3.74, 4, 6.76, 7.07 ;2-3-7
giFtBell5of6 ftgen 25, 0, 6, -2, 1.19, 2, 3.74, 4, 4.76, 6.07 ;
giFtBell6of6 ftgen 26, 0, 6, -2, 1.19, 3.74, 4, 4.76, 7, 7.07
;esc/res 3
giFtSpreiz1of5 ftgen 31, 0, 6, -2, 1, 1.978, 3.213, 4.710, 6.452, 8.324 ;röhrenglocke: spreizung 1 - 1.2 - 1.5 - 1.7 - 1.9
giFtSpreiz2of5 ftgen 32, 0, 6, -2, 1, 2.3, 3, 5.1, 7.4, 10.3 ;spreizung 1.3 - 1.7 - 2.1 - 2.3 - 2.9
giFtSpreiz3of5 ftgen 33, 0, 6, -2, 1, 2.7, 4.8, 7.1, 10, 13.5 ;spreizung 1.7 - 2.1 - 2.3 - 2.9 - 3.5
giFtSpreiz4of5 ftgen 34, 0, 6, -2, 1, 2.32, 4.25, 6.63, 9.38, 13 ;weinglas: spreizung 2.2 - 3 - 0 - 3.7 - 4.2
giFtSpreiz5of5 ftgen 35, 0, 6, -2, 1, 3.2, 6.23, 6.27, 9.92, 14.15 ;topfdeckel: spreizung 1.3 - 1.9 - 2.4 - 2.7 - 3.6



/***********/
/* SAMPLES */
/***********/

/* SNARE */
gi_snare1_f_ord1 ftgen 0, 0, 0, 1, "snare1_f_ord1.wav", 0, 0, 1
gi_snare1_f_ord3 ftgen 0, 0, 0, 1, "snare1_f_ord3.wav", 0, 0, 1
gi_snare1_f_rim1 ftgen 0, 0, 0, 1, "snare1_f_rim1.wav", 0, 0, 1
gi_snare1_f_rim3 ftgen 0, 0, 0, 1, "snare1_f_rim3.wav", 0, 0, 1
gi_snare1_f_rim4 ftgen 0, 0, 0, 1, "snare1_f_rim4.wav", 0, 0, 1
gi_snare1_f_rim6 ftgen 0, 0, 0, 1, "snare1_f_rim6.wav", 0, 0, 1
gi_snare1_p_rim1 ftgen 0, 0, 0, 1, "snare1_p_rim1.wav", 0, 0, 1
gi_snare1_p_rim3 ftgen 0, 0, 0, 1, "snare1_p_rim3.wav", 0, 0, 1
gi_snare1_klack_rim1 ftgen 0, 0, 0, 1, "snare1_klack_rim1.wav", 0, 0, 1
gi_snare1_jazz_1 ftgen 0, 0, 0, 1, "snare1_jazz_1.wav", 0, 0, 1

gi_snare2_f_ord1 ftgen 0, 0, 0, 1, "snare2_f_ord1.wav", 0, 0, 1
gi_snare2_f_rim4 ftgen 0, 0, 0, 1, "snare2_f_rim4.wav", 0, 0, 1
gi_snare2_f_rim5 ftgen 0, 0, 0, 1, "snare2_f_rim5.wav", 0, 0, 1
gi_snare2_nah_trocken_1 ftgen 0, 0, 0, 1, "snare2_nah_trocken_1.wav", 0, 0, 1
gi_snare2_pp_1 ftgen 0, 0, 0, 1, "snare2_pp_1.wav", 0, 0, 1
gi_snare2_pp_8_rand ftgen 0, 0, 0, 1, "snare2_pp_8_rand.wav", 0, 0, 1
gi_snare2_p_rim2 ftgen 0, 0, 0, 1, "snare2_p_rim2.wav", 0, 0, 1
gi_snare2_jazz_1 ftgen 0, 0, 0, 1, "snare2_jazz_1.wav", 0, 0, 1
gi_snare2_jazz_5 ftgen 0, 0, 0, 1, "snare2_jazz_5.wav", 0, 0, 1
gi_snare2_jazz_druck_1 ftgen 0, 0, 0, 1, "snare2_jazz_druck_1.wav", 0, 0, 1


/* PEITSCHE ETC */
gi_castagnetten2 ftgen 0, 0, 0, 1, "castagnetten2.wav", 0, 0, 1
gi_claves3 ftgen 0, 0, 0, 1, "claves3.wav", 0, 0, 1
gi_peitsche1 ftgen 0, 0, 0, 1, "peitsche1.wav", 0, 0, 1
gi_peitsche2 ftgen 0, 0, 0, 1, "peitsche2.wav", 0, 0, 1
gi_HandKlatsch ftgen 0, 0, 0, 1, "HandKlatsch.aif", 0, 0, 1 ;nicht trocken
gi_wblk_kaputt ftgen 0, 0, 0, 1, "wblk_kaputt.wav", 0, 0, 1
gi_papierschlag ftgen 0, 0, 0, 1, "papierschlag.wav", 0, 0, 1

/* ANDERES */
gi_demo1 ftgen 0, 0, 0, 1, "demo1.aif", 0, 0, 1
gi_demo2 ftgen 0, 0, 0, 1, "demo2.aif", 0, 0, 1
gi_demo3 ftgen 0, 0, 0, 1, "demo3.aif", 0, 0, 1
gi_Kistebrech ftgen 0, 0, 0, 1, "Kistebrech.aif", 0, 0, 1
gi_Kistebrech2 ftgen 0, 0, 0, 1, "Kistebrech2.aif", 0, 0, 1
gi_regen_freetown ftgen 0, 0, 0, 1, "regen_freetown.aif", 0, 0, 1
gi_schwein1 ftgen 0, 0, 0, 1, "schwein1.aif", 0, 0, 1
gi_schwein2 ftgen 0, 0, 0, 1, "schwein2.aif", 0, 0, 1
gi_schwein3 ftgen 0, 0, 0, 1, "schwein3.aif", 0, 0, 1
gi_schwein4 ftgen 0, 0, 0, 1, "schwein4.aif", 0, 0, 1
gi_Schweinefuettern ftgen 0, 0, 0, 1, "Schweinefuettern.aif", 0, 0, 1
giHalfSine ftgen 0, 0, 4096, 9, 1/2, 1, 0



opcode RndInt, i,ii
 iMin, iMax xin
 iRnd random iMin, iMax+.999
 xout int(iRnd)
endop

opcode RndInt, k,kk
 kMin, kMax xin
 kRnd random kMin, kMax+.999
 xout int(kRnd)
endop

  opcode Linek, kk, kkkk
;performs a linear interpolation from kthis to knext in ktim whenever ktrig is 1
kthis, knext, ktim, ktrig xin 
kstat     init      0 ;status at the begin
kfin      init      0
knprd     =         round(ktim*kr) ;number of k-cycles for ktim
ktimek    timek
 if ktrig == 1 then ;freeze values 
kthistim  =         ktimek 
kstrt     =         kthis
kend      =         knext
kstat     =         1
 endif
 if kstat == 0 then
kval      =         kthis
 elseif kstat == 1 then
kcount    =         ktimek-kthistim ;number of k-cycles in the time needed
kinc      =         (kend-kstrt) / knprd ;increment
kval      =         kstrt + kcount * kinc 
  if ktimek == kthistim+knprd then ;if target reached
kfin      =         1 ;tell it
kstat     =         2 ;set status
  else
kfin      =         0
  endif
 elseif kstat == 2 then
kval      =         kval ;stay at kval if no new trigger
kfin      =         0
 endif
          xout      kval, kfin ;value and 1 if target reached
  endop



instr B

 iNoteDur = 1/8
 iNumNotes = 65
 iExpectedDur = iNoteDur * iNumNotes
 p3 = iExpectedDur * 2
 kNoteDur init iNoteDur
 kSpeed = 1
 kDbMedi linseg -25, iExpectedDur/2, -25, iExpectedDur/2, -25
 kDb randomi kDbMedi-10, kDbMedi+10, 1/4, 3
 kNoteCnt init 1
 kAccents[] fillarray 4, 1, 5, 2, 6, 11, 7, 12, 9
 kIndxAccents init -1
 kRtmCnt init 0
 iStartAzi = -85
 iEndAzi = -iStartAzi
 iNoReverb = 0
 iReverb = 1
  
 kAziBase linseg iStartAzi, iExpectedDur, iEndAzi
 kAziMaxDev linseg 10, iExpectedDur*.8, 80, iExpectedDur*.2, 0
  
 kTrig metro 1/kNoteDur
 
 if kTrig == 1 then

  kAziThisDev random -kAziMaxDev, kAziMaxDev
  kAzi = kAziBase + kAziThisDev
  
  if kRtmCnt == 0 then
   iProbability = 0.3 ;prob for being resonated
   kThisReverb = (random:k(0,1) > iProbability) ? iReverb : iNoReverb
   event "i", "PlayWarp", 0, 1, gi_snare1_f_ord3, kSpeed, random:k(-9,0), kAzi, 1, kThisReverb
   kIndxAccents = (kIndxAccents+1) % lenarray(kAccents)
   kRtmCnt = kAccents[kIndxAccents]
   ;printks "kRtmCnt = %d\n", 0, kRtmCnt
  else
   kDb random kDb-3, kDb+3
   event "i", "PlayWarp", 0, 1, gi_snare1_f_ord3, kSpeed, kDb, kAzi, 1, iNoReverb
  endif
  
  if kNoteCnt > iNumNotes then
   printks "Time at End of B: %.1f\n", 0, times:k()
   turnoff
  endif
  kNoteCnt += 1
  kRtmCnt -= 1
  kNoteDur random iNoteDur*.9, iNoteDur*1.1
 
 endif
 
endin

instr C

 iNoteDur1 = 1/8 ;start
 iNoteDur2 = 1/4 ;end
 iNumNotes = 113
 iExpectedDur = (iNoteDur1+iNoteDur2)/2 * iNumNotes
 p3 = iExpectedDur * 2
 kDbMedi linseg -30, iExpectedDur/2, -15, iExpectedDur/2, -20
 kDbChangeRate linseg 1/8, iExpectedDur, 1/4
 kDb randomi kDbMedi-6, kDbMedi+6, kDbChangeRate, 3
 kNoteCnt init 1
 kAccents[] fillarray 4, 1, 5, 2, 6, 11, 7, 12, 9
 kIndxAccents init 9 ;rueckwaerts und minus 1
 kRtmCnt init 0
 kRtmCntPlus init 0
 iNoReverb = 0
 iReverb = 1
  
 kThisNoteDur, kNextNoteDur init iNoteDur1
 kTimInt init 1
 kTrigNewTempo init 1
 kNoteDurGlob, k0 Linek kThisNoteDur, kNextNoteDur, kTimInt, kTrigNewTempo
 kTrigNewTempo = 0
 kNoteDur, kNoteDurGlob init iNoteDur1
 kNoteDurRndMedi linseg 0, iExpectedDur/2, 0.1, iExpectedDur/2, 0.2 ;gets more irregular

 kAziTargets[] fillarray 85, 40, 60, 25, 35, -5, 20, -30, -10, -50, -20, -80, -50
 kAziTargetsIndx init 0
 
 kTrig metro 1/kNoteDur
 
 if kTrig == 1 then
  
  if kRtmCnt == 0 then
   kThisAccAzi = kAziTargets[kAziTargetsIndx]
   kSpeed = 1
   kProbability = 0.3 ;prob for being resonated
   kThisReverb = (random:k(0,1) > kProbability) ? iReverb : iNoReverb
   event "i", "PlayWarp", 0, 1, gi_snare1_f_ord3, kSpeed, random:k(-9,-0), kThisAccAzi, 1, kThisReverb
   event "i", "PlayWarp", 0, 1, gi_snare1_f_ord3, kSpeed, random:k(-12,-6), kThisAccAzi, .1, kThisReverb
   kIndxAccents = kIndxAccents == 0 ? lenarray(kAccents)-1 : kIndxAccents-1
   kRtmCnt = kAccents[kIndxAccents] + kRtmCntPlus
   kRtmCntPlus += 1 ;mach quasi rit in akzenten
   ;printks "kRtmCnt = %d\n", 0, kRtmCnt
   ;jeder akzent setzt ein neues tempo, zu dem sich die folgenden schlaege hinbewegen
   kThisNoteDur = kNextNoteDur
   kFlipFlop init 0
   if kFlipFlop % 2 == 0 then
    kNextNoteDur = iNoteDur2
   else
    kNextNoteDur = iNoteDur1
   endif
   kFlipFlop += 1
   kTimInt = ((kThisNoteDur+kNextNoteDur) / 2) * kRtmCnt
   kTrigNewTempo = 1
   
   kAziTargetsIndx += 1
   kNextAccAzi = kAziTargets[kAziTargetsIndx]
   kAziDiff = kNextAccAzi - kThisAccAzi
   kAziStepDiff = kAziDiff / kRtmCnt
   kAziStep = kThisAccAzi
   ;printks "kThisAccAzi = %d, kNextAccAzi = %d, kAziDiff = %d, kRtmCnt = %d\n", 0, kThisAccAzi, kNextAccAzi, kAziDiff, kRtmCnt
   kThisAccAzi = kNextAccAzi
   ;printk 0, kAziTargetsIndx   
   
  else
   kAziStep += kAziStepDiff
   ;printks "  kAziStep = %d\n", 0, kAziStep
   kDb random kDb-3, kDb+3
   kSpeed random -50, 0
   kStretch random .5, 1
   event "i", "PlayWarp", 0, 1, gi_snare1_f_ord3, cent(kSpeed), kDb, kAziStep, kStretch
  endif
  
  if kNoteCnt > iNumNotes then
   printks "Time at End of C: %.1f\n", 0, times:k()
   turnoff
  endif

  kNoteCnt += 1
  kRtmCnt -= 1
  kNoteDur random kNoteDurGlob*2^(-kNoteDurRndMedi), kNoteDurGlob*2^kNoteDurRndMedi
 
 endif

endin

instr D ;erstmal ohne

 iNoteDur = p4
 iNumNotes = p5
 iAziMin = p6
 iAziMax = p7
 iDbMax = p8
 iPropMax = p9 ;wo ist der höhepunkt
 iPropRest = 1-iPropMax
 iExpectedDur = iNoteDur*iNumNotes
 p3 = iExpectedDur * 2
 kSpeed = 1
 kDbMedi linseg -35, iExpectedDur*iPropMax, iDbMax, iExpectedDur*iPropRest, -45
 kNoteDurMedi linseg iNoteDur, iExpectedDur*.2, iNoteDur*.8, iExpectedDur*.8, iNoteDur*1.5
 kNoteCnt init 1
 kNoteDur init iNoteDur
 
 kTrig metro 1/kNoteDur
 
 if kTrig == 1 then
 
  kAzi random iAziMin, iAziMax
  kDb random kDbMedi-3, kDbMedi+3
  kStretch random 1,3
  event "i", "PlayWarp", 0, 1, gi_snare1_f_ord3, random:k(.95,1.1), kDb, kAzi, kStretch
  
  kNoteDur random kNoteDurMedi*.9, kNoteDurMedi*1.1
  kNoteCnt += 1
  
  if kNoteCnt > iNumNotes then
   printks "Time at End of D: %.1f\n", 0, times:k()
   turnoff
  endif
 endif
 
endin

instr PlayWarp

 iTab = p4
 iSpeed = p5
 iDb = p6
 iAzi = p7
 iStretch = p8
 iReverb = 0 ;p9 ;0=no 1=yes
 p3 = ftlen(iTab)/sr/iSpeed/iStretch
 iDryLevel = giDryLevel
 giPlayCnt += 1
 
 iTimeMode = 0 ;scaling, no pointer
 iWindowSize = sr/10
 iRandWin = iWindowSize/5
 iOverlap = 25

 aWarp sndwarp ampdb(iDb), iStretch, iSpeed, iTab, 0, iWindowSize, iRandWin, iOverlap, giHalfSine, iTimeMode

 ;for the resonator call: call one instance of ClFilt (which calls Comb and Ambi) with unique audio channel
 if iReverb == 1 then
  schedule "ResonParams", 0, 1, times:i()
  schedule "ClFilt", 0, p3*2, giPlayCnt, iSpeed
  chnset aWarp*ampdb(iDryLevel), sprintf("%s_%d_dry", "playcnt", giPlayCnt)
 endif
 
 ;send to internal audio channels (4 or 8)
 if giChannelSetup == 4.4 then
  aOut[] init 4
  aOut vbap aWarp*ampdb(iDryLevel), iAzi, 0, 0, 2
  chnmix aOut[0], "chn_esc_1"
  chnmix aOut[1], "chn_esc_2"
  chnmix aOut[2], "chn_esc_3"
  chnmix aOut[3], "chn_esc_4" 
 
 else ;8 and 2 both use internal 8 channels
  aOut[] init 8
  aOut vbap aWarp*ampdb(iDryLevel), iAzi, 0, 0, 1
  chnmix aOut[0], "chn_esc_1"
  chnmix aOut[1], "chn_esc_2"
  chnmix aOut[2], "chn_esc_3"
  chnmix aOut[3], "chn_esc_4"
  chnmix aOut[4], "chn_esc_5"
  chnmix aOut[5], "chn_esc_6"
  chnmix aOut[6], "chn_esc_7"
  chnmix aOut[7], "chn_esc_8"
 
 endif

endin

instr ResonParams

 iTime = p4
 print iTime
 
 giCombLowestPitch = giBasePitch
 
 if iTime < 9 then
 
  giDryLevel = 0 ;db
  giClFiltMainFreqPartial = 11 ;giCombLowestPitch multiplied by this number = clfiltcutoff
  giClFiltVol = -20 ;db = was überhaupt in den resonator kommt
  giCombRvrbTim = 15 ;sec
  giCombMaxCentDev = 100 ;cent
  giCombPartialsFt = giFtBell1of6
  giCombVol = 0 ; db = was geht aus comb raus
  giCombFadeIn = 1
  giCombMix = 0.1 ;anteil daran von ClFilt (0=nur clfilt) oder comb (1=nur comb)
  giAmbiAziDist = 15 ;abstand der sechs einzelnen comb teiltöne in ambi (normal = 15°)
  
 elseif iTime < 14.1 then
  giBasePitch = 55*(16/15) ;quasi reset

 elseif iTime < 21 then
  giCombPartialsFt = giFtBell2of6

 elseif iTime < 34 then
  giClFiltMainFreqPartial = 9
  giClFiltVol = -20 ;db = was überhaupt in den resonator kommt
  giCombMix = .2
 else

 
 endif

  giPitchSeriesCnt += 1
  giBasePitch *= giPitchSeriesProps[giPitchSeriesCnt]
   
  giCombFadeOut = giCombRvrbTim / 2

   ;print giBasePitch, giCombLowestPitch
    
 turnoff

endin


instr ClFilt

 p3 = giCombRvrbTim ;macht keinen sinn es länger laufen zu lassen
 iClFiltVol = giClFiltVol ;db
 iCutOff = giCombLowestPitch * giClFiltMainFreqPartial ;also 11. teilton
 print iCutOff, iClFiltVol
 iType = 0 ;low pass
 iNpoles = 70 ;number of poles (even)
 iKind = 1 ;0=butter, 1,2=cheby
 iPassBdRipple = 1 ;default = 1 (db)
 iStopBand = -60 ;default = -60 dB
 
 iPlayCnt = p4
 aDry chnget sprintf("%s_%d_dry", "playcnt", iPlayCnt)
 aClFilt clfilt aDry, iCutOff, iType, iNpoles, iKind, iPassBdRipple, iStopBand
 aClFilt dcblock aClFilt

 schedule "Comb", 0, p3, iPlayCnt
 chnset aClFilt*ampdb(iClFiltVol), sprintf("%s_%d_clfilt", "playcnt", iPlayCnt)
 
endin


instr Comb

 iPlayCnt = p4
 aClFilt chnget sprintf("%s_%d_clfilt", "playcnt", iPlayCnt)

 iCombLowestPitch = giCombLowestPitch
 iCombRvrbTim = giCombRvrbTim
 iCombMaxCentDev = giCombMaxCentDev
 iCombPartialsFt = giCombPartialsFt
 iCombVol = giCombVol
 iCombFadeIn = giCombFadeIn
 iCombFadeOut = giCombFadeOut
 iCombMix = giCombMix
 iAmbiAziDist = giAmbiAziDist
 print iCombLowestPitch, iCombRvrbTim, iCombMaxCentDev, iCombPartialsFt, iCombVol, iCombFadeIn, iCombFadeOut, iCombMix, iAmbiAziDist

 kEnv linen 1, iCombFadeIn, p3, iCombFadeOut
 iMaxTim = 1
 iLow = -iCombMaxCentDev
 iHigh = iCombMaxCentDev
 
 iArrayProps[] init 6
 copyf2array iArrayProps, iCombPartialsFt

 acomb1 vcomb aClFilt, iCombRvrbTim, 1/iCombLowestPitch*(1/iArrayProps[0])*cent(randomi:k(iLow,iHigh,1/8,3)), iMaxTim
 acomb2 vcomb aClFilt, iCombRvrbTim, 1/iCombLowestPitch*(1/iArrayProps[1])*cent(randomi:k(iLow,iHigh,1/7,3)), iMaxTim
 acomb3 vcomb aClFilt, iCombRvrbTim, 1/iCombLowestPitch*(1/iArrayProps[2])*cent(randomi:k(iLow,iHigh,1/6,3)), iMaxTim
 acomb4 vcomb aClFilt, iCombRvrbTim, 1/iCombLowestPitch*(1/iArrayProps[3])*cent(randomi:k(iLow,iHigh,1/5,3)), iMaxTim
 acomb5 vcomb aClFilt, iCombRvrbTim, 1/iCombLowestPitch*(1/iArrayProps[4])*cent(randomi:k(iLow,iHigh,1/4,3)), iMaxTim
 acomb6 vcomb aClFilt, iCombRvrbTim, 1/iCombLowestPitch*(1/iArrayProps[5])*cent(randomi:k(iLow,iHigh,1/3,3)), iMaxTim
 
 acomb1_mix ntrpol aClFilt, acomb1, iCombMix
 acomb2_mix ntrpol aClFilt, acomb2, iCombMix
 acomb3_mix ntrpol aClFilt, acomb3, iCombMix
 acomb4_mix ntrpol aClFilt, acomb4, iCombMix
 acomb5_mix ntrpol aClFilt, acomb5, iCombMix
 acomb6_mix ntrpol aClFilt, acomb6, iCombMix

 chnset acomb1_mix*ampdb(iCombVol)*kEnv, sprintf("%s_%d_comb_1", "playcnt", iPlayCnt)
 chnset acomb2_mix*ampdb(iCombVol)*kEnv, sprintf("%s_%d_comb_2", "playcnt", iPlayCnt)
 chnset acomb3_mix*ampdb(iCombVol)*kEnv, sprintf("%s_%d_comb_3", "playcnt", iPlayCnt)
 chnset acomb4_mix*ampdb(iCombVol)*kEnv, sprintf("%s_%d_comb_4", "playcnt", iPlayCnt)
 chnset acomb5_mix*ampdb(iCombVol)*kEnv, sprintf("%s_%d_comb_5", "playcnt", iPlayCnt)
 chnset acomb6_mix*ampdb(iCombVol)*kEnv, sprintf("%s_%d_comb_6", "playcnt", iPlayCnt)
 
 ;call six instances of ambi for the six signals and pass the azimuth, band and play count
 iAzi random 0, 360
 iCnt = 0
 while iCnt < 6 do
  schedule "Ambi", 0, p3, iPlayCnt, iAzi, iCnt+1
  iAzi += iAmbiAziDist
  iCnt += 1
 od

endin


instr Ambi

 iPlayCnt = p4
 iAzi = p5
 iBand = p6 ;1..6

 Schnl sprintf "%s_%d_comb_%d", "playcnt", iPlayCnt, iBand
 aIn chnget Schnl
 
 aBform[] init 4 ;evt höhere ordnung probieren
 aBform bformenc1 aIn, iAzi, 0
 
 if giChannelSetup == 4.4 then
  aOut[] init 4
  aOut bformdec1 2, aBform

  chnmix aOut[0], "chn_res_1" ;FL = 1 in üblicher (vbap) zählung
  chnmix aOut[1], "chn_res_4" ;BL = 4
  chnmix aOut[2], "chn_res_3" ;BR = 3
  chnmix aOut[3], "chn_res_2" ;FR = 2  
  
 else ;8 or 2
  aOut[] init 8
  aOut bformdec1 4, aBform

  chnmix aOut[0], "chn_res_1" ;FFL = 1 in üblicher zählung
  chnmix aOut[1], "chn_res_8" ;FLL = 8
  chnmix aOut[2], "chn_res_7" ;BLL = 7
  chnmix aOut[3], "chn_res_6" ;BBL = 6
  chnmix aOut[4], "chn_res_5" ;BBR = 5
  chnmix aOut[5], "chn_res_4" ;BRR = 4
  chnmix aOut[6], "chn_res_3" ;FRR = 3
  chnmix aOut[7], "chn_res_2" ;FFR = 2
  
 endif
 
endin


instr Collect

 if giChannelSetup == 4.4 then
 
  ;get the esc channels and write to channel 1-4
  aEsc_1 chnget "chn_esc_1"
  aEsc_2 chnget "chn_esc_2"
  aEsc_3 chnget "chn_esc_3"
  aEsc_4 chnget "chn_esc_4"  
  outch 1, aEsc_1*ampdb(giGlobGainDb), 2, aEsc_2*ampdb(giGlobGainDb), 3, aEsc_3*ampdb(giGlobGainDb), 4, aEsc_4*ampdb(giGlobGainDb)
  
  ;get the res channels and write to channel 5-8
  aRes_1 chnget "chn_res_1"
  aRes_2 chnget "chn_res_2"
  aRes_3 chnget "chn_res_3"
  aRes_4 chnget "chn_res_4"  
  outch 5, aRes_1*ampdb(giGlobGainDb), 6, aRes_2*ampdb(giGlobGainDb), 7, aRes_3*ampdb(giGlobGainDb), 8, aRes_4*ampdb(giGlobGainDb)

  ;clear channels
  chnclear "chn_esc_1"
  chnclear "chn_esc_2"
  chnclear "chn_esc_3"
  chnclear "chn_esc_4" 
  chnclear "chn_res_1"
  chnclear "chn_res_2"
  chnclear "chn_res_3"
  chnclear "chn_res_4"
  
 else ;octo or stereo
 
  ;get the esc and the res channels
  aEsc_1 chnget "chn_esc_1"
  aEsc_2 chnget "chn_esc_2"
  aEsc_3 chnget "chn_esc_3"
  aEsc_4 chnget "chn_esc_4" 
  aEsc_5 chnget "chn_esc_5"
  aEsc_6 chnget "chn_esc_6"
  aEsc_7 chnget "chn_esc_7"
  aEsc_8 chnget "chn_esc_8" 
  aRes_1 chnget "chn_res_1"
  aRes_2 chnget "chn_res_2"
  aRes_3 chnget "chn_res_3"
  aRes_4 chnget "chn_res_4" 
  aRes_5 chnget "chn_res_5"
  aRes_6 chnget "chn_res_6"
  aRes_7 chnget "chn_res_7"
  aRes_8 chnget "chn_res_8" 
     
  ;if octo, put out (1-8 = esc, 9-16 = res)
  if giChannelSetup == 8.8 then
   outch 1, aEsc_1*ampdb(giGlobGainDb), 2, aEsc_2*ampdb(giGlobGainDb), 3, aEsc_3*ampdb(giGlobGainDb), 4, aEsc_4*ampdb(giGlobGainDb), 
   		5, aEsc_5*ampdb(giGlobGainDb), 6, aEsc_6*ampdb(giGlobGainDb), 7, aEsc_7*ampdb(giGlobGainDb), 8, aEsc_8*ampdb(giGlobGainDb)
   outch 9, aRes_1*ampdb(giGlobGainDb), 10, aRes_2*ampdb(giGlobGainDb), 11, aRes_3*ampdb(giGlobGainDb), 12, aRes_4*ampdb(giGlobGainDb),
   		13, aRes_5*ampdb(giGlobGainDb), 14, aRes_6*ampdb(giGlobGainDb), 15, aRes_7*ampdb(giGlobGainDb), 16, aRes_8*ampdb(giGlobGainDb)
   
  ;if stereo with live mix put out esc=1-2 and res=3-4
  elseif giChannelSetup == 2.2 then  
   aEscL1, aEscR1 pan2 aEsc_1, 4/9
   aEscL2, aEscR2 pan2 aEsc_2, 5/9
   aEscL3, aEscR3 pan2 aEsc_3, 6/9
   aEscL4, aEscR4 pan2 aEsc_4, 7/9
   aEscL5, aEscR5 pan2 aEsc_5, 8/9
   aEscL6, aEscR6 pan2 aEsc_6, 1/9
   aEscL7, aEscR7 pan2 aEsc_7, 2/9
   aEscL8, aEscR8 pan2 aEsc_8, 3/9
   aEscL sum aEscL1, aEscL2, aEscL3, aEscL4, aEscL5, aEscL6, aEscL7, aEscL8
   aEscR sum aEscR1, aEscR2, aEscR3, aEscR4, aEscR5, aEscR6, aEscR7, aEscR8
   aResL1, aResR1 pan2 aRes_1, 4/9
   aResL2, aResR2 pan2 aRes_2, 5/9
   aResL3, aResR3 pan2 aRes_3, 6/9
   aResL4, aResR4 pan2 aRes_4, 7/9
   aResL5, aResR5 pan2 aRes_5, 8/9
   aResL6, aResR6 pan2 aRes_6, 1/9
   aResL7, aResR7 pan2 aRes_7, 2/9
   aResL8, aResR8 pan2 aRes_8, 3/9
   aResL sum aResL1, aResL2, aResL3, aResL4, aResL5, aResL6, aResL7, aResL8
   aResR sum aResR1, aResR2, aResR3, aResR4, aResR5, aResR6, aResR7, aResR8
   outch 1, aEscL, 2, aEscR
   outch 3, aResL, 4, aResR
     
  ;if simple stereo, mix all to 1-2 (6 7 8 1 2 3 4 5)  
  elseif giChannelSetup == 2.0 then
   aL1, aR1 pan2 aEsc_1+aRes_1, 4/9
   aL2, aR2 pan2 aEsc_2+aRes_2, 5/9
   aL3, aR3 pan2 aEsc_3+aRes_3, 6/9
   aL4, aR4 pan2 aEsc_4+aRes_4, 7/9
   aL5, aR5 pan2 aEsc_5+aRes_5, 8/9
   aL6, aR6 pan2 aEsc_6+aRes_6, 1/9
   aL7, aR7 pan2 aEsc_7+aRes_7, 2/9
   aL8, aR8 pan2 aEsc_8+aRes_8, 3/9
   aL sum aL1, aL2, aL3, aL4, aL5, aL6, aL7, aL8
   aR sum aR1, aR2, aR3, aR4, aR5, aR6, aR7, aR8
   out aL*ampdb(giGlobGainDb), aR*ampdb(giGlobGainDb)
 
  ;if none of these ...
  else 
   prints "ERROR! Channel Setup '%.1f' not known!\n", giChannelSetup
   
  endif

  ;clear channels
  chnclear "chn_esc_1"
  chnclear "chn_esc_2"
  chnclear "chn_esc_3"
  chnclear "chn_esc_4" 
  chnclear "chn_esc_5"
  chnclear "chn_esc_6"
  chnclear "chn_esc_7"
  chnclear "chn_esc_8" 
  chnclear "chn_res_1"
  chnclear "chn_res_2"
  chnclear "chn_res_3"
  chnclear "chn_res_4" 
  chnclear "chn_res_5"
  chnclear "chn_res_6"
  chnclear "chn_res_7"
  chnclear "chn_res_8" 
    
 endif

endin
schedule("Collect",0,60)


</CsInstruments>
<CsScore>
a 0 0 0
i "B" 0 1 
b 14
i "C" 0 1
b 41 
;         ;not dur | num notes | azi min/max | db max | prop max
i "D" 0 1 [1/20] 33 -30 30 -20 .3
i "D" 3 1 [1/25] 44 30 60 -15 .5
i "D" 6.5 1 [1/20] 11 -60 -30 -25 .2
</CsScore>
</CsoundSynthesizer>
<bsbPanel>
 <label>Widgets</label>
 <objectName/>
 <x>536</x>
 <y>128</y>
 <width>320</width>
 <height>240</height>
 <visible>true</visible>
 <uuid/>
 <bgcolor mode="nobackground">
  <r>255</r>
  <g>255</g>
  <b>255</b>
 </bgcolor>
 <bsbObject version="2" type="BSBButton">
  <objectName>_Browse1</objectName>
  <x>121</x>
  <y>102</y>
  <width>100</width>
  <height>30</height>
  <uuid>{0557b9d2-bfb6-456f-8982-1158d1126a20}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <type>value</type>
  <pressedValue>1.00000000</pressedValue>
  <stringvalue>/home/jh/Desktop/BratscheStereo.aiff</stringvalue>
  <text>Open File</text>
  <image>/</image>
  <eventLine>i1 0 10</eventLine>
  <latch>false</latch>
  <latched>false</latched>
 </bsbObject>
 <bsbObject version="2" type="BSBGraph">
  <objectName/>
  <x>58</x>
  <y>52</y>
  <width>350</width>
  <height>150</height>
  <uuid>{a2a34f6b-7610-464d-86bb-d1137ccf571c}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <value>0</value>
  <objectName2/>
  <zoomx>1.00000000</zoomx>
  <zoomy>1.00000000</zoomy>
  <dispx>1.00000000</dispx>
  <dispy>1.00000000</dispy>
  <modex>lin</modex>
  <modey>lin</modey>
  <all>true</all>
 </bsbObject>
</bsbPanel>
<bsbPresets>
</bsbPresets>
